<?php

function diff_string( $old, $new )
{
	$old = explode( "\n", "\n" . $old );
	$new = explode( "\n", "\n" . $new );
	$r   = count( $new ) < count( $old );

	if ( $r ) {
		$m = count( $new );
		$n = count( $old );
		$A = $new;
		$B = $old;
	}
	else {
		$m = count( $old );
		$n = count( $new );
		$A = $old;
		$B = $new;
	}
	for ( $i = -$m - 2 ; $i <= $n; ++$i ) {
		$fp[$i] = -1;
	}
	$d = $n - $m;
	$pa[-1] = array();

	for ( $p = 0; ; ++$p ) {
		for ( $k = -$p; $k < $d; ++$k ) {
			if ( $fp[$k - 1] >= $fp[$k + 1] ) {
				$pa[$k] = $pa[$k - 1];
				$x = ( $y = $fp[$k - 1] + 1 ) - $k;
			}
			else {
				$pa[$k] = $pa[$k + 1];
				$x = ( $y = $fp[$k + 1] ) - $k;
			}
			while ( $x + 1 < $m && $y + 1 < $n && $A[$x + 1] === $B[$y + 1] ) {
				$pa[$k][] = array( ++$x, ++$y );
			}
			$fp[$k] = $y;
		}
		for ( $k = $d + $p; $k > $d; --$k ) {
			if ( $fp[$k - 1] >= $fp[$k + 1] ) {
				$pa[$k] = $pa[$k - 1];
				$x = ( $y = $fp[$k - 1] + 1 ) - $k;
			}
			else {
				$pa[$k] = $pa[$k + 1];
				$x = ( $y = $fp[$k + 1] ) - $k;
			}
			while ( $x + 1 < $m && $y + 1 < $n && $A[$x + 1] === $B[$y + 1] ) {
				$pa[$k][] = array( ++$x, ++$y );
			}
			$fp[$k] = $y;
		}
		if ( $fp[$d - 1] >= $fp[$d + 1] ) {
			$pa[$d] = $pa[$d - 1];
			$x = ( $y = $fp[$d - 1] + 1 ) - $d;
		}
		else {
			$pa[$d] = $pa[$d + 1];
			$x = ( $y = $fp[$d + 1] ) - $d;
		}
		while ( $x + 1 < $m && $y + 1 < $n && $A[$x + 1] === $B[$y + 1] ) {
			$pa[$d][] = array( ++$x, ++$y );
		}
		if ( $y >= $n ) {
			break;
		}
		$fp[$d] = $y;
	}
	$pos = $pa[$d];
	$pos[] = array( $m, $n );

	$x = $y = 1;
	$s = '';
	if ( $r ) {
		foreach ( $pos as $p ) {
			while ( $p[1] > $x ) { $s .= '< ' . $B[$x++] . "\n"; }
			while ( $p[0] > $y ) { $s .= '> ' . $A[$y++] . "\n"; }
			if ( $x < $n )       { $s .= '  ' . $B[$x]   . "\n"; }
			++$x;
		   	++$y;
		}
	}
	else {
		foreach ( $pos as $p ) {
			while ( $p[0] > $x ) { $s .= '< ' . $A[$x++] . "\n"; }
			while ( $p[1] > $y ) { $s .= '> ' . $B[$y++] . "\n"; }
			if ( $x < $m )       { $s .= '  ' . $A[$x]   . "\n"; }
			++$x;
		   	++$y;
		}
	}
	return $s;
}
