<?php
if ( basename( $_SERVER['SCRIPT_NAME'] ) === basename( __FILE__ ) ) { exit; }

$conf =& Config::getInstance();

include( VIEW_DIR . 'view_default.tpl.php' );

$host  = get_hostname();
$page  = $host . WEB_SELF;

$title = $conf->get( 'title', TOOL_NAME );
$lang  = $conf->get( 'message_lang' );

echo '<?xml version="1.0" encoding="UTF-8"?>' . "\n";
?>
<rdf:RDF
 xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
 xmlns="http://purl.org/rss/1.0/"
 xmlns:taxo="http://purl.org/rss/1.0/modules/taxonomy/"
 xmlns:dc="http://purl.org/dc/elements/1.1/"
 xmlns:syn="http://purl.org/rss/1.0/modules/syndication/"
 xmlns:admin="http://webns.net/mvcb/"
>

<channel rdf:about="<?php p( $page ) ?>">
<title><?php p( $title ) ?> RSS</title>
<link><?php p( $page ) ?></link>
<description><?php p( $title ) ?></description>
<dc:language><?php p( $lang ) ?></dc:language>
<items>
 <rdf:Seq>
<?php foreach ( $items as $item ) : ?>
  <rdf:li rdf:resource="<?php p( $item['uri'] ) ?>" />
<?php endforeach ?>
 </rdf:Seq>
</items>
</channel>

<?php foreach ( $items as $item ) : ?>
<item rdf:about="<?php p( $item['uri'] ) ?>">
<title><?php p( $item['title'] ) ?></title>
<link><?php p( $host . $to_link . u( $item['uri'] ) . '&' . $item['lflag'] ) ?></link>
<dc:date><?php p( $item['date'] ) ?></dc:date>
<description><?php p( $item['diff'] ) ?></description>
</item>
<?php endforeach ?>

</rdf:RDF>
