<?php
if ( basename( $_SERVER['SCRIPT_NAME'] ) === basename( __FILE__ ) ) { exit; }

$conf =& Config::getInstance();
$get  =& Request::getInstance( '_GET' );

if ( ! is_dir( ITEM_DIR ) ) { @mkdir( ITEM_DIR, 0707 ) && touch( ITEM_DIR . 'index.html' ); }
if ( ! is_dir( LOGS_DIR ) ) { @mkdir( LOGS_DIR, 0707 ) && touch( LOGS_DIR . 'index.html' ); }
if ( ! is_dir( TEMP_DIR ) ) { @mkdir( TEMP_DIR, 0707 ) && touch( TEMP_DIR . 'index.html' ); }

$top_page    = WEB_SELF;
$filter_page = $top_page . '?mode=filter';
$status_page = $top_page . '?mode=status';
$config_page = $top_page . '?mode=config';

$self  = $config_page;
$user  = $conf->isAuth() ? $conf->get( 'user' ) : '';

$class = $get->get( 'c',    '' );
$link  = $get->get( 'link', '' );
$uri   = ( $link && Validate::isUri( $link ) ) ? $link : 'http://';
$last  = $conf->get( 'last-modified' );
$last  = $last ? date( "Y/m/d H:i:s", $last ) : '----/--/--';

$proxy      = $conf->get( 'proxy' );
$use_proxy  = (bool)$conf->get( 'use-proxy' );
$diff_count = (int)$conf->get( 'diff_count' );
$diff_comm  = $conf->get( 'diff_command' );
$php_cli    = $conf->get( 'php_command' );

// category
$cate =& Category::getInstance();
$categories = $cate->get();
unset( $cate );

if ( $class === 'd' ) {
	$styles = array();
	$curcss = $conf->get( 'css' );
	foreach ( glob( SELF_DIR . 'css/*.css' ) as $file ) {
		$title = '';
		if ( preg_match( '/^title:(.*)$/um', file_get_contents( $file ), $m ) ) {
			$title = $m[1];
		}
		$filename = basename( $file, '.css' );
		$styles[$filename] = $title . ' <' . $filename . '>' ;
	}
	$limit = $conf->get( 'lim', 24 );
	$visit = $conf->get( 'vis', TRUE );
}
