<?php
if ( basename( $_SERVER['SCRIPT_NAME'] ) === basename( __FILE__ ) ) { exit; }

$conf =& Config::getInstance();

$top_page     = WEB_SELF;
$filter_page  = $top_page . '?mode=filter';
$status_page  = $top_page . '?mode=status';
$config_page  = $top_page . '?mode=config';
$setting_page = $top_page . '?mode=setting&uri=';

$last = $conf->get( 'last-modified' );
$last = $last ? date( "Y/m/d H:i:s", $last ) : '----/--/--';

$items = array();
foreach ( $data as $key => $info ) {
	$last_m = (int)ifsetor( $info['last_modified'], 0 );
	$last_v = (int)ifsetor( $info['last_visit'],    0 );
	$last_c = (int)ifsetor( $info['last_check'],    0 );
	$count  = (int)ifsetor( $info['count'],         0 );

	$status = ifsetor( $info['status'], 'OK' );

	$items[] = array(
		'title' => $info['title'],
		'uri'   => $setting_page . u( $info['uri'] ),
		'check' => date( "m/d H:i", $last_c ),
		'lflag' => date( 'mdHi',    $last_m ),
		'date'  => ( $last_m ? date( 'Y/m/d',   $last_m ) : '----/--/--' ),
		'count' => $count,
		'stat'  => $status,
	);
}
usort( $items, create_function( '$a, $b', '
	$c = 1;
	$d = 1;
	if ( $a["stat"] === "OK" ) { $c = -1; }
	if ( $b["stat"] === "OK" ) { $d = -1; }
	if ( $a["stat"] === "Not Modified" ) { $c = -2; }
	if ( $b["stat"] === "Not Modified" ) { $d = -2; }

	return $c < $d;
' ) );
